<?php
/*
 * This file is part of EC-CUBE
 *
 * Copyright(c) 2000-2013 LOCKON CO.,LTD. All Rights Reserved.
 *
 * http://www.lockon.co.jp/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

require_once("../require.php");
require_once CLASS_EX_REALDIR . 'page_extends/admin/LC_Page_Admin_Ex.php';

/**
 * アップグレード用クラス
 * @author Spirit of Co.,Ltd.
 */

class SoUpgradeFile {
    function SoUpgradeFile() {
        SC_Utils_Ex::sfIsSuccess(new SC_Session_Ex());

        $this->update_title = 'Security Update 2013/05 v1.0';

        $objLayout = new SC_Helper_PageLayout_Ex();

        $this->mobile_tpl_dir = $objLayout->getTemplatePath(DEVICE_TYPE_MOBILE);
        $this->sphone_tpl_dir = $objLayout->getTemplatePath(DEVICE_TYPE_SMARTPHONE);
        $this->default_tpl_dir = $objLayout->getTemplatePath(DEVICE_TYPE_PC);

        $this->version = ECCUBE_VERSION;

        if (version_compare(ECCUBE_VERSION, '2.11.0') < 0) {
            $this->version = false;
        } else if(version_compare(ECCUBE_VERSION, '2.11.0') == 0) {
            $this->version = '2.11.0';
        } else if(version_compare(ECCUBE_VERSION, '2.11.1') <= 0) {
            $this->version = '2.11.1';
        } else if(version_compare(ECCUBE_VERSION, '2.11.2') <= 0) {
            $this->version = '2.11.2';
        } else if(version_compare(ECCUBE_VERSION, '2.11.3') <= 0) {
            $this->version = '2.11.3';
        } else if(version_compare(ECCUBE_VERSION, '2.11.4') <= 0) {
            $this->version = '2.11.4';
        } else if(version_compare(ECCUBE_VERSION, '2.11.5') <= 0) {
            $this->version = '2.11.5';
        } else if(version_compare(ECCUBE_VERSION, '2.12.0') <= 0) {
            $this->version = '2.12.0';
        } else if(version_compare(ECCUBE_VERSION, '2.12.1') <= 0) {
            $this->version = '2.12.1';
        } else if(version_compare(ECCUBE_VERSION, '2.12.2') <= 0) {
            $this->version = '2.12.2';
        } else if(version_compare(ECCUBE_VERSION, '2.12.3') <= 0) {
            $this->version = '2.12.3';
        } else if(version_compare(ECCUBE_VERSION, '2.12.4') < 0) {
            $this->version = '2.12.3';
        } else if(version_compare(ECCUBE_VERSION, '2.12.4') >= 0) {
            $this->version = false;
        }

        switch ($this->version) {
            case '2.11.0';
                $this->arrCheckFile = array(
                    CLASS_REALDIR . "pages/forgot/LC_Page_Forgot.php" => 'f26d3ade73dc314f4d96e55022defb12d7c59e43',
                    CLASS_EX_REALDIR . "page_extends/forgot/LC_Page_Forgot_Ex.php" => 'e8c150e057d7c2b9795ac08646a6c5071a2b1dd7',
                    CLASS_REALDIR . "pages/cart/LC_Page_Cart.php" => '3df0b442e261220563cb17093e635df6712dd411',
                    CLASS_EX_REALDIR . "page_extends/cart/LC_Page_Cart_Ex.php" => '74885a732207574d805768c9f3d26ab4901215c2',
                    CLASS_EX_REALDIR . "helper_extends/SC_Helper_Session_Ex.php" => '5961187e2bf1a0da31788cee015ee68eaa967daf',
                    CLASS_REALDIR . "helper/SC_Helper_Session.php" => 'eee2720e74354b9c0a496163b5c9723fee91dd61',
                );
                break;
            case '2.11.1';
                $this->arrCheckFile = array(
                    CLASS_REALDIR . "pages/forgot/LC_Page_Forgot.php" => '4b9b2f4902327a2f02e0fb932b91eb1af936932b',
                    CLASS_EX_REALDIR . "page_extends/forgot/LC_Page_Forgot_Ex.php" => 'e8c150e057d7c2b9795ac08646a6c5071a2b1dd7',
                    CLASS_REALDIR . "pages/cart/LC_Page_Cart.php" => '0d23d0157e673f8a75dc7b5bfc2004f15476773f',
                    CLASS_EX_REALDIR . "page_extends/cart/LC_Page_Cart_Ex.php" => '74885a732207574d805768c9f3d26ab4901215c2',
                    CLASS_EX_REALDIR . "helper_extends/SC_Helper_Session_Ex.php" => '5961187e2bf1a0da31788cee015ee68eaa967daf',
                    CLASS_REALDIR . "helper/SC_Helper_Session.php" => 'eee2720e74354b9c0a496163b5c9723fee91dd61',
                );
                break;
            case '2.11.2';
                $this->arrCheckFile = array(
                    CLASS_REALDIR . "pages/forgot/LC_Page_Forgot.php" => '1cd45117bf9f33ac39a5ee98025f9e13df5d38f3',
                    CLASS_EX_REALDIR . "page_extends/forgot/LC_Page_Forgot_Ex.php" => 'e8c150e057d7c2b9795ac08646a6c5071a2b1dd7',
                    CLASS_REALDIR . "pages/cart/LC_Page_Cart.php" => 'fa966b9ad857951cc6ff23d1584225ea35391ef8',
                    CLASS_EX_REALDIR . "page_extends/cart/LC_Page_Cart_Ex.php" => '74885a732207574d805768c9f3d26ab4901215c2',
                    CLASS_EX_REALDIR . "helper_extends/SC_Helper_Session_Ex.php" => '5961187e2bf1a0da31788cee015ee68eaa967daf',
                    CLASS_REALDIR . "helper/SC_Helper_Session.php" => '9df35f7cc435ccd011916e275813e6e2293a1a19',
                );
                break;
            case '2.11.3';
            case '2.11.4';
                $this->arrCheckFile = array(
                    CLASS_REALDIR . "pages/forgot/LC_Page_Forgot.php" => '1cd45117bf9f33ac39a5ee98025f9e13df5d38f3',
                    CLASS_EX_REALDIR . "page_extends/forgot/LC_Page_Forgot_Ex.php" => 'e8c150e057d7c2b9795ac08646a6c5071a2b1dd7',
                    CLASS_REALDIR . "pages/cart/LC_Page_Cart.php" => '54e56e607ad6c1f9ef0ca6dbbaec82d24f22f563',
                    CLASS_EX_REALDIR . "page_extends/cart/LC_Page_Cart_Ex.php" => '74885a732207574d805768c9f3d26ab4901215c2',
                    CLASS_EX_REALDIR . "helper_extends/SC_Helper_Session_Ex.php" => '5961187e2bf1a0da31788cee015ee68eaa967daf',
                    CLASS_REALDIR . "helper/SC_Helper_Session.php" => 'd59a21465ccfa319a02299805d2517b7abc9c21a',
                );
                break;
            case '2.11.5';
                $this->arrCheckFile = array(
                    CLASS_REALDIR . "pages/forgot/LC_Page_Forgot.php" => '65e2712f3faab4d6bdfd98befef228a7a2a20665',
                    CLASS_EX_REALDIR . "page_extends/forgot/LC_Page_Forgot_Ex.php" => 'e8c150e057d7c2b9795ac08646a6c5071a2b1dd7',
                    CLASS_REALDIR . "pages/cart/LC_Page_Cart.php" => '1e2a2edceec81f24a5d628fbf7a8a5b9138b8e40',
                    CLASS_EX_REALDIR . "page_extends/cart/LC_Page_Cart_Ex.php" => '74885a732207574d805768c9f3d26ab4901215c2',
                    CLASS_EX_REALDIR . "helper_extends/SC_Helper_Session_Ex.php" => '5961187e2bf1a0da31788cee015ee68eaa967daf',
                    CLASS_REALDIR . "helper/SC_Helper_Session.php" => '11b99072e92faeab3c0bfff1d1ccad87addfc4da',
                );
                break;
            case '2.12.0';
                $this->arrCheckFile = array(
                    CLASS_REALDIR . "pages/forgot/LC_Page_Forgot.php" => '6b8159eb94fdcb08dacde37aad3d8827115ef754',
                    CLASS_EX_REALDIR . "page_extends/forgot/LC_Page_Forgot_Ex.php" => 'ba793e0225e0b69f89b10d32c3141339c27c7c28',
                    CLASS_REALDIR . "pages/cart/LC_Page_Cart.php" => 'db67720c310e9fb530eef2793fac0d576902396a',
                    CLASS_EX_REALDIR . "page_extends/cart/LC_Page_Cart_Ex.php" => '069cf6ff3e5a311fdec02edfdd7eedbe45c73e21',
                    CLASS_EX_REALDIR . "helper_extends/SC_Helper_Session_Ex.php" => '5e6a77468cea27c246eee0a4f236c46c5d782f46',
                    CLASS_REALDIR . "helper/SC_Helper_Session.php" => 'd5e5f9a8b543294b18609ef5a411e8a0898b865c',
                );
                break;
            case '2.12.1';
                $this->arrCheckFile = array(
                    CLASS_REALDIR . "pages/forgot/LC_Page_Forgot.php" => '6b2e861c77b2145304021a7fbed3b092cac31c60',
                    CLASS_EX_REALDIR . "page_extends/forgot/LC_Page_Forgot_Ex.php" => 'ba793e0225e0b69f89b10d32c3141339c27c7c28',
                    CLASS_REALDIR . "pages/cart/LC_Page_Cart.php" => 'f020d872bb577eb6041d8f064b95b7841657903f',
                    CLASS_EX_REALDIR . "page_extends/cart/LC_Page_Cart_Ex.php" => '069cf6ff3e5a311fdec02edfdd7eedbe45c73e21',
                    CLASS_EX_REALDIR . "helper_extends/SC_Helper_Session_Ex.php" => '5e6a77468cea27c246eee0a4f236c46c5d782f46',
                    CLASS_REALDIR . "helper/SC_Helper_Session.php" => 'd5e5f9a8b543294b18609ef5a411e8a0898b865c',
                );
                break;
            case '2.12.2';
                $this->arrCheckFile = array(
                    CLASS_REALDIR . "pages/forgot/LC_Page_Forgot.php" => 'e0456c6a2db42fa0c3b801465c9cd323f28b4f79',
                    CLASS_EX_REALDIR . "page_extends/forgot/LC_Page_Forgot_Ex.php" => 'ba793e0225e0b69f89b10d32c3141339c27c7c28',
                    CLASS_REALDIR . "pages/cart/LC_Page_Cart.php" => '7ed627a65e5f7a8acc02c420b55df21fbdf0d623',
                    CLASS_EX_REALDIR . "page_extends/cart/LC_Page_Cart_Ex.php" => '069cf6ff3e5a311fdec02edfdd7eedbe45c73e21',
                    CLASS_EX_REALDIR . "helper_extends/SC_Helper_Session_Ex.php" => '5e6a77468cea27c246eee0a4f236c46c5d782f46',
                    CLASS_REALDIR . "helper/SC_Helper_Session.php" => 'd5e5f9a8b543294b18609ef5a411e8a0898b865c',
                );
                break;
            case '2.12.3';
                $this->arrCheckFile = array(
                    CLASS_REALDIR . "pages/forgot/LC_Page_Forgot.php" => '439b595240bfb28d798ae59d64ccfb343fa44ad2',
                    CLASS_EX_REALDIR . "page_extends/forgot/LC_Page_Forgot_Ex.php" => '126f7de32caa2d3f3baa5b669a10be9018d4f075',
                    CLASS_REALDIR . "pages/cart/LC_Page_Cart.php" => '200eaf594b7d1f9e53d027c59a15f614ed73b782',
                    CLASS_EX_REALDIR . "page_extends/cart/LC_Page_Cart_Ex.php" => 'b5c96d3409c78dbf6d14f6f2d36ed85f6eedc332',
                    CLASS_EX_REALDIR . "helper_extends/SC_Helper_Session_Ex.php" => 'd7775db66ae5a13f53154f3f7295fa4eaed9b518',
                    CLASS_REALDIR . "helper/SC_Helper_Session.php" => '0c814f7dc7b075283269f9d34ed0598198b1689e',
                );
                break;
            default:
                break;
        }
        // テンプレートはハッシュチェック対象外
        $this->arrCheckFile[$this->default_tpl_dir . 'shopping/multiple.tpl'] = '';
        $this->arrCheckFile[$this->sphone_tpl_dir . 'shopping/multiple.tpl'] = '';
        $this->arrCheckFile[$this->mobile_tpl_dir . 'shopping/multiple.tpl'] = '';

        if (is_file(MODULE_REALDIR . 'mdl_pg_mulpay/inc/include.php')
                && version_compare(ECCUBE_VERSION, '2.11.5') <= 0) {
            $this->arrCheckFile[CLASS_EX_REALDIR . "page_extends/cart/LC_Page_Cart_Ex.php"] = '';
        }

        $this->arrUpdateFile = array(
            CLASS_REALDIR . "pages/forgot/LC_Page_Forgot.php",
            CLASS_REALDIR . "pages/cart/LC_Page_Cart.php",
            CLASS_REALDIR . "helper/SC_Helper_Session.php",
            $this->default_tpl_dir . 'shopping/multiple.tpl',
            $this->sphone_tpl_dir . 'shopping/multiple.tpl',
            $this->mobile_tpl_dir . 'shopping/multiple.tpl',
        );

        $this->arrUpdateData = array(
            $this->default_tpl_dir . 'shopping/multiple.tpl' =>
                array( 'tpl_replace' =>
                    array('value[$index]}-->' => 'value[$index]|h}-->'),
                    ),
            $this->sphone_tpl_dir . 'shopping/multiple.tpl' =>
                array( 'tpl_replace' =>
                    array('value[$index]}-->' => 'value[$index]|h}-->'),
                    ),
            $this->mobile_tpl_dir . 'shopping/multiple.tpl' =>
                array( 'tpl_replace' =>
                    array('value[$index]}-->' => 'value[$index]|h}-->'),
                    ),
            CLASS_REALDIR . "pages/forgot/LC_Page_Forgot.php" =>
                array( 'replace' =>
                    array('(email Like ? OR email_mobile Like ?) AND name01 Like ? AND name02 Like ?'
                            => '(email = ? OR email_mobile = ?) AND name01 = ? AND name02 = ?',

                         '"(email Like ? OR email_mobile Like ?)"'  // 2.11用
                            => '\'(email = ? OR email_mobile = ?)\'',

                         '" AND name01 Like ? AND name02 Like ?"'
                            => '\' AND name01 = ? AND name02 = ?\'',

                         "'(email Like ? OR email_mobile Like ?)'"  // 2.12用
                            => '\'(email = ? OR email_mobile = ?)\'',

                         "' AND name01 Like ? AND name02 Like ?'"
                            => '\' AND name01 = ? AND name02 = ?\'',
                        ),
                     ),
            CLASS_REALDIR . "pages/cart/LC_Page_Cart.php" =>
                array( 'replace' =>
                    array('lfInitParam($_REQUEST)'
                            => 'lfInitParam($_POST)',

                          '"EXIST_CHECK", "ZERO_CHECK", "NUM_CHECK", "MAX_LENGTH_CHECK"'    // 2.11用
                            => '"ZERO_CHECK", "NUM_CHECK", "MAX_LENGTH_CHECK"',

                          "'EXIST_CHECK', 'ZERO_CHECK', 'NUM_CHECK', 'MAX_LENGTH_CHECK'"    // 2.12用
                            => "'ZERO_CHECK', 'NUM_CHECK', 'MAX_LENGTH_CHECK'",

                          '$cartKey = $objFormParam->getValue(\'cartKey\');'
                            => <<<EOD
\$cartKey = \$objFormParam->getValue('cartKey');

        // エラーチェック
        \$arrError = \$objFormParam->checkError();
        if(isset(\$arrError) && !empty(\$arrError)) {
            SC_Utils_Ex::sfDispSiteError(CART_NOT_FOUND);
            SC_Response_Ex::actionExit();
        }

EOD
                        ,
                          '$this->mode = $this->getMode();'
                          => <<<EOD
\$this->mode = \$this->getMode();

        // モバイル対応
        if(SC_Display_Ex::detectDevice() == DEVICE_TYPE_MOBILE) {
            if(isset(\$_GET['cart_no'])) \$objFormParam->setValue('cart_no', \$_GET['cart_no']);
            if(isset(\$_GET['cartKey'])) \$objFormParam->setValue('cartKey', \$_GET['cartKey']);
        }

EOD
                        ),
                    ),
            CLASS_REALDIR . "helper/SC_Helper_Session.php" =>
                array( 'func' => array('adminAuthorization' => <<<EOD

    function adminAuthorization()
    {
        if ((\$script_path = realpath(\$_SERVER['SCRIPT_FILENAME'])) !== FALSE) {
            \$arrScriptPath = explode('/', str_replace('\\\\\\\\', '/', \$script_path));
            \$arrAdminPath = explode('/', str_replace('\\\\\\\\', '/', substr(HTML_REALDIR . ADMIN_DIR, 0, -1)));
            \$arrDiff = array_diff_assoc(\$arrAdminPath, \$arrScriptPath);
            if (in_array(substr(ADMIN_DIR, 0, -1), \$arrDiff)) {
                return;
            } else {
                \$masterData = new SC_DB_MasterData_Ex();
                \$arrExcludes = \$masterData->getMasterData('mtb_auth_excludes');
                foreach (\$arrExcludes as \$exclude) {
                    \$arrExcludesPath = explode('/', str_replace('\\\\\\\\', '/', HTML_REALDIR . ADMIN_DIR . \$exclude));
                    \$arrDiff = array_diff_assoc(\$arrExcludesPath, \$arrScriptPath);
                    if (count(\$arrDiff) === 0) {
                        return;
                    }
                }
            }
        }
        SC_Utils_Ex::sfIsSuccess(new SC_Session_Ex());
    }

EOD
                    ),
                ),
        );

        $this->arrCheckMsg = array(
            '「パスワードの再発行」の機能が正常に動作する事を確認下さい。',
            '管理画面にログインが出来る事を確認下さい。',
            'カートへの商品追加が出来る事を確認下さい。',
            'カートへの商品追加とその後の購入への移動が出来る事を確認下さい。',
            'お届け先複数指定が出来る事を確認下さい。',
            );
        $this->arrResults = array();
    }

    function check() {
        foreach ($this->arrCheckFile as $path => $hash) {
            if (!is_file($path)) {
                $this->arrErr[$path] = "ファイルが存在しません\n $path";
                GC_Utils_Ex::gfPrintLog("ファイルが存在しません\n $path");
                continue;
            }
            if ($hash == '') {
                continue;
            }
            GC_Utils_Ex::gfPrintLog("hash check:" . "$path = " . sha1_file($path));
            if (sha1_file($path) != $hash) {
                $file_data = file_get_contents($path);
                if (strpos($file_data, $this->update_title) === FALSE) {
                    $this->arrErr[$path] = 'ファイルが標準状態と異なります。自動更新出来ませんので手動で更新が必要です。';
                    GC_Utils_Ex::gfPrintLog('ファイルが標準状態と異なります。自動更新出来ませんので手動で更新が必要です。 => ' . $path);
                } else {
                    $this->arrErr[$path] = 'ファイルに更新済みの記録がされています。念のため更新が適用されていることを確認して下さい。';
                    GC_Utils_Ex::gfPrintLog('ファイルに更新済みの記録がされています。念のため更新が適用されていることを確認して下さい。 => ' . $path);
                }
            }
        }

        foreach ($this->arrUpdateFile as $path) {
            if (!is_writable($path)) {
                $this->arrErr2[$path] = "ファイルに書き込めません\n $path に書込権限が必要です。";
                GC_Utils_Ex::gfPrintLog("ファイルに書き込めません\n $path に書込権限が必要です。");
            } else if (!is_writable(dirname($path))) {
                $this->arrErr2[$path] = "ディレクトリに書き込み権限がありません。 \n" . dirname($path) . " に書込権限が必要です。";
                GC_Utils_Ex::gfPrintLog("ディレクトリに書き込み権限がありません。 \n" . dirname($path) . " に書込権限が必要です。");
            }
        }

    }

    function update() {
        $replace_prg_msg = '/* Spirit of verup program ' . $this->update_title . " updated\n"
                 . '   ' . __FILE__ . "\n"
                 . '   Spirit of Co.,Ltd. http://www.spiritof.jp/ ' . "\n"
                 . '*/' . "\n";
        foreach ($this->arrUpdateData as $path => $data) {
            $backup_path = $path . ".bak" . date('YmdHis') . ".php";
            $res = copy($path, $backup_path);
            if ($res === FALSE) {
                $this->arrErr[$path] = "バックアップファイルが作成出来ませんでした。\n" . dirname($path) . "に書込権限が必要です。";
                GC_Utils_Ex::gfPrintLog("バックアップファイルが作成出来ませんでした。\n" . dirname($path) . "に書込権限が必要です。");
                continue;
            } else {
                $this->arrResults[] = "バックアップファイルを作成しました。 => " . $backup_path;
                GC_Utils_Ex::gfPrintLog("バックアップファイルを作成しました。 => " . $backup_path);
            }
            foreach ($data as $action => $action_data) {
                switch ($action) {
                case 'tpl_replace':
                    $file_data = file_get_contents($path);
                    $file_data = '<!--{*' . "\n" . $replace_prg_msg . '*}-->' ."\n" . $file_data;
                    foreach ($action_data as $search_data => $replace_data) {
                        $file_data = str_replace($search_data, $replace_data, $file_data);
                        $counter += $counter_temp;
                    }
                    $res = file_put_contents($path, $file_data);
                    if ($res === FALSE) {
                        $this->arrErr[$path] = "ファイルへの書き込みが正常に終了しませんでした。\n $path の内容を確認して手動で更新が必要です。";
                        GC_Utils_Ex::gfPrintLog("ファイルへの書き込みが正常に終了しませんでした。\n $path の内容を確認して手動で更新が必要です。");

                    } else {
                        $this->arrResults[] = "ファイルに修正内容を適用しました。=> " . $path;
                        GC_Utils_Ex::gfPrintLog("ファイルに修正内容を適用しました。=> " . $path);
                    }
                    break;
                case 'replace':
                    $file_data = file_get_contents($path);
                    $file_data = str_replace('class ', $replace_prg_msg . 'class ', $file_data);
                    foreach ($action_data as $search_data => $replace_data) {
                        $file_data = str_replace($search_data, $replace_data, $file_data);
                    }
                    $res = file_put_contents($path, $file_data);
                    if ($res === FALSE) {
                        $this->arrErr[$path] = "ファイルへの書き込みが正常に終了しませんでした。\n $path の内容を確認して手動で更新が必要です。";
                        GC_Utils_Ex::gfPrintLog("ファイルへの書き込みが正常に終了しませんでした。\n $path の内容を確認して手動で更新が必要です。");
                    } else {
                        $this->arrResults[] = "ファイルに修正内容を適用しました。 => " . $path;
                        GC_Utils_Ex::gfPrintLog("ファイルに修正内容を適用しました。 => " . $path);
                    }
                    break;
                case 'func':
                    $file_data = file_get_contents($path);
                    foreach ($action_data as $func_name => $replace_data) {
                        $replace_function_name = $func_name . '_old_' . date('YmdHis');
                        $replace_function_line = $replace_data . $replace_prg_msg . "    " . 'function ' . $replace_function_name . ' (';
                        $file_data = preg_replace('/\s*function ' . $func_name . '\s*\(/', $replace_function_line, $file_data);
                    }
                    $res = file_put_contents($path, $file_data);
                    if ($res === FALSE) {
                        $this->arrErr[$path] = "ファイルへの書き込みが正常に終了しませんでした。\n $path の内容を確認して手動で更新が必要です。";
                        GC_Utils_Ex::gfPrintLog("ファイルへの書き込みが正常に終了しませんでした。\n $path の内容を確認して手動で更新が必要です。");
                    } else {
                        $this->arrResults[] = "ファイルに修正内容を適用しました。 => " . $path;
                        GC_Utils_Ex::gfPrintLog("ファイルに修正内容を適用しました。 => " . $path);
                    }
                }
            }
        }
    }

}

/**
 * ページクラス
 * @author Spirit of Co.,Ltd.
 */

class LC_Page_Admin_SoUpgrade extends LC_Page_Admin_Ex {

    /**
     * Page を初期化する.
     *
     * @return void
     */
    function init() {
        parent::init();
        $this->template = DATA_REALDIR . "downloads/tmp/soupgrade.tpl";
    }

    /**
     * Page のプロセス.
     *
     * @return void
     */
    function process() {
        parent::process();
        $this->action();
        $this->sendResponse();
    }

    /**
     * Page のアクション.
     *
     * @return void
     */
    function action() {
        if (!is_file($this->template)) {
            SC_Utils_Ex::sfDispException("テンプレートファイルが生成されていません。");
            exit;
        }

        $this->mode = $this->getMode();
        $obj = new SoUpgradeFile();
        $this->version = $obj->version;

        switch($this->mode) {
            case 'check':
                $obj->check();
                $this->arrErr = $obj->arrErr;
                $this->arrErr2 = $obj->arrErr2;
                if (SC_Utils_Ex::isBlank($this->arrErr) && SC_Utils_Ex::isBlank($this->arrErr2)) {
                    $this->is_next = true;
                } else {
                    $this->is_next = false;
                }
                break;
            case 'confirm':
                $obj->update();
                $this->arrErr = $obj->arrErr;
                $this->arrResults = $obj->arrResults;
                $this->arrCheckMsg = $obj->arrCheckMsg;

                break;
            default:
                break;
        }
    }

    /**
     * デストラクタ.
     *
     * @return void
     */
    function destroy() {
        parent::destroy();
    }
}


$page_template =<<<EOD
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=<!--{\$smarty.const.CHAR_CODE}-->">
<meta http-equiv="content-script-type" content="text/javascript">
<meta http-equiv="content-style-type" content="text/css">
<link rel="stylesheet" href="<!--{\$TPL_URLPATH}-->css/reset.css" type="text/css" media="all" />
<link rel="stylesheet" href="<!--{\$TPL_URLPATH}-->css/admin_contents.css" type="text/css" media="all" />
<script type="text/javascript" src="<!--{\$smarty.const.ROOT_URLPATH}-->js/navi.js"></script>
<script type="text/javascript" src="<!--{\$smarty.const.ROOT_URLPATH}-->js/site.js"></script>
<script type="text/javascript" src="<!--{\$smarty.const.ROOT_URLPATH}-->js/jquery-1.4.2.min.js"></script>
<title>管理機能</title>
<link rel="shortcut icon" href="<!--{\$TPL_URLPATH}-->img/common/favicon.ico" />
<link rel="icon" type="image/vnd.microsoft.icon" href="<!--{\$TPL_URLPATH}-->img/common/favicon.ico" />
<script type="text/javascript">//<![CDATA[
    <!--{\$tpl_javascript}-->
    \$(function(){
        <!--{\$tpl_onload}-->
    });
//]]></script>

</head>

<body>
<!--{\$GLOBAL_ERR}-->
<noscript>
    <p>JavaScript を有効にしてご利用下さい.</p>
</noscript>
<div id="login">
<div id="login-wrap" style="background:url('');margin-top:50px;">

    <div id="login-form" class="clearfix">
    <h2>EC-CUBE 2013年5月セキュリティアップデート 自動適用プログラム</h2>
    <div style="line-height:1.4em">
            <form name="form1" id="form1" method="post" action="?">
            <input type="hidden" name="<!--{\$smarty.const.TRANSACTION_ID_NAME}-->" value="<!--{\$transactionid}-->" />
            <input type="hidden" name="mode" value="check" />

            <!--{if \$mode == ''}-->
            本プログラムは、以下の2013年5月セキュリティアップデートの内容を自動で適用します。<br />
            ・パスワードリマインド機能における不適切な入力確認の脆弱性<br />
            ・一部環境における、管理画面の不適切な認証に関する脆弱性<br />
            ・カート画面でのXSS脆弱性<br />
            ・お届け先複数指定画面でのXSS脆弱性<br />
            <br />
            <span class="attention">以下のご注意事項をお読み頂き、ご了承された場合のみ利用して下さい。</span><br />
            <br />
            ご注意事項<br />
            ・本プログラムは標準状態のEC-CUBEを前提としてアップデートを行います。<br />
            ・安全に自動アップデートするため適用可能か自動検証しますが、関係するファイルにカスタマイズがされている場合は自動的にアップデートを取りやめます。カスタマイズがされていて自動適用出来ない場合は手動での更新が必要です。<br />
            ・本プログラムは入念なテストと安全な適用が出来るよう開発されていますが、安全のため利用時には<span class="attention">必ずシステムファイルやデータのバックアップを全て行った上で実行して下さい。</span>(EC-CUBE管理画面のバックアップ機能はデータのみのバックアップです。）<br />
            <br />

            ・本プログラムはEC-CUBE本体と同様のライセンスで無償提供されています。<br />
            ・本プログラムの利用に関しては利用者自らが全ての責任を負うものとします。<br />

            ・本プログラムの利用に関し提供会社は保証行為はしておらず内容などの正確性に対する保証は一切ありません。また利用した事に起因する直接的または間接的な損害に関して提供会社の責に帰すべき事由いかんに依らず一切責任を負いません。<br />
            <br />
            ・本プログラムに関するご質問などは、開発コミュニティをご利用下さい。<br />
            ・本プログラムに関して有償でのアップデート作業や調査のご依頼やご相談をされたい場合は下記の提供会社またはEC-CUBEインテグレートパートナー各社に、ご相談下さい。
            <br />
            ※提供会社： <a href="http://www.spiritof.jp/" target="_blank">株式会社スピリット・オブ</a><br />
            ※インテグレートパートナー各社：<a href="http://www.ec-cube.net/integrate/partner/" target="_blank">EC-CUBEインテグレートパートナー</a><br />

            <br />
            まずは下のボタンを押して自動適用可能か確認をしてください。
            <div class="btn-area" style="padding: 20px;">
                <ul>
                    <li><a class="btn-action" href="javascript:;" onclick="fnFormModeSubmit('form1', 'check', '', ''); return false;"><span class="btn-next">ご注意事項を了承し、チェックへ進む</span></a></li>
                </ul>
            </div>
            <!--{elseif \$mode == 'check'}-->
                <!--{if \$version == ""}-->
                更新の必要は無いバージョンです。
                <!--{else}-->

                ■ EC-CUBEバージョン: <!--{\$version}--> （自動認識値）<br />
                <br />
                ■ 自動適用チェック 検証結果<br />
                <!--{foreach from=\$arrErr item=data key=key}-->
                    ファイル: <!--{\$key}--><br />
                    エラー内容:<br /><!--{\$data}--><br /><br />
                <!--{foreachelse}-->
                    自動適用可能です。<br />
                <!--{/foreach}-->
                <br />
                ■ ファイル権限チェック 検証結果<br />
                <!--{foreach from=\$arrErr2 item=data key=key}-->
                    ファイル: <!--{\$key}--><br />
                    エラー内容: <!--{\$data}--><br /><br />
                <!--{foreachelse}-->
                    自動適用可能です。<br />
                <!--{/foreach}-->
                <!--{if \$is_next}-->
                <br />
                <br />
                下記ボタンを押して画面を進めて下さい。
                    <div class="btn-area" style="padding: 20px;">
                        <ul>
                            <li><a class="btn-action" href="javascript:;" onclick="fnFormModeSubmit('form1', '', '', ''); return false;"><span class="btn-prev">戻る</span></a></li>
                            <li><a class="btn-action" href="javascript:;" onclick="fnFormModeSubmit('form1', 'confirm', '', ''); return false;"><span class="btn-next">更新を適用する</span></a></li>
                        </ul>
                    </div>
                <!--{else}-->
                <br />
                <br />
                エラーがあるため進めません。エラー内容を確認して、戻って再度実行して下さい。
                    <div class="btn-area" style="padding: 20px;">
                        <ul>
                            <li><a class="btn-action" href="javascript:;" onclick="fnFormModeSubmit('form1', '', '', ''); return false;"><span class="btn-prev">戻る</span></a></li>
                        </ul>
                    </div>
                <!--{/if}-->

                <!--{/if}-->
             <br />
            ・本プログラムに関するご質問などは、開発コミュニティをご利用下さい。<br />
            ・本プログラムに関して有償でのアップデート作業や調査をご依頼やご相談をされたい場合は下記の提供会社またはEC-CUBEインテグレートパートナー各社に、ご相談下さい。
            <br />
            ※提供会社： <a href="http://www.spiritof.jp/" target="_blank">株式会社スピリット・オブ</a><br />
            ※インテグレートパートナー各社：<a href="http://www.ec-cube.net/integrate/partner/" target="_blank">EC-CUBEインテグレートパートナー</a><br /><br />

            <!--{elseif \$mode == 'confirm'}-->
                ■ 自動適用結果<br />
                <!--{foreach from=\$arrErr item=data key=key}-->
                    ファイル: <!--{\$key}--><br />
                    エラー内容:<br /><!--{\$data}--><br /><br />
                <!--{foreachelse}-->
                    自動適用は正常に終了しました。<br />
                    <span class="attention">本プログラムは必ず削除して下さい。</span><br />
                <!--{/foreach}-->
                <br />
                ■ 動作確認<br />
                <span class="attention">下記の動作確認を必ず行って下さい。</span><br />
                <!--{foreach from=\$arrCheckMsg item=data key=key}-->
                    ・<!--{\$data}--><br />
                <!--{/foreach}-->
                <br />
                ■ 適用ログ<br />
                <dl>
                <!--{foreach from=\$arrResults item=data key=key}-->
                    <dt><!--{\$key}-->:</dt><dd><!--{\$data}--></dd>
                <!--{/foreach}-->
                </dl>
             <br />
            ・本プログラムに関するご質問などは、開発コミュニティをご利用下さい。<br />
            ・本プログラムに関して有償でのアップデート作業や調査をご依頼やご相談をされたい場合は下記の提供会社またはEC-CUBEインテグレートパートナー各社に、ご相談下さい。
            <br />
            ※提供会社： <a href="http://www.spiritof.jp/" target="_blank">株式会社スピリット・オブ</a><br />
            ※インテグレートパートナー各社：<a href="http://www.ec-cube.net/integrate/partner/" target="_blank">EC-CUBEインテグレートパートナー</a><br /><br />
            <!--{/if}-->
            </form>
    </div>
    </div>

</div>
<div id="copyright">Copyright &copy; 2013 <a href="http://www.spiritof.jp/" target="_blank">Spirit of Co.,Ltd. All rights reserved.</a> / Copyright &copy; 2000-2013 LOCKON CO.,LTD. All Rights Reserved.</div>

</div>
</body>
</html>
EOD;

$tpl_tmp_path = DATA_REALDIR . "downloads/tmp/soupgrade.tpl";
if (is_file($tpl_tmp_path)) {
    unlink($tpl_tmp_path);
}
file_put_contents($tpl_tmp_path, $page_template);



$objPage = new LC_Page_Admin_SoUpgrade();
register_shutdown_function(array($objPage, 'destroy'));
$objPage->init();
$objPage->process();
